100 E$=CHR$(27): '                 Escape Character
110 CLS$=CHR$(26): '               Clear Screen
120 DC$=E$+"=": '                  Direct Cursor Addressing
130 ERA$=E$+"T": '                 Erase to End of Line
140 DY$=E$+")": '                  DIM Display On
150 DN$=E$+"(": '                  DIM Display Off
160 UY$=E$+"l": '                  Start Underlining
170 UN$=E$+"m": '                  End Underlining
180 CR$=CHR$(13): '                Carriage Return
190 BS$=CHR$(8): '                 Backspace
200 BU$=CHR$(19): '                Backup
210 BEL$=CHR$(7): '                Bell
220 US$="_": '                     Underscore
230 BL$=" ": '                     Blank (space)
240 NUL$="": '                     Null
250 CO$=DC$+"9"+" ": '             Cursor Off (cursor off display screen)
260 PRINT CLS$ ' signin please...
270 CLOSE
280 DEFINT A-M,O-U,W-Z
290 SC=1:PR=2:MV=20:L3=0:LN=80:FC=32:LC=126
300 DIM N$(20),V$(20),I$(80),W$(100),T(10),OPER(10,10),NUM(10,10)
310 OU=SC:KEY$="OFF" ' default output to screen ' default to normal keyboard
320 ' print header
330 PRINT UY$;STRING$(52," ");UN$
340 PRINT:PRINT SPC(8);"BIZCALC Programmable Desk Calculator"
350 PRINT UY$;STRING$(52," ");UN$
360 PRINT:PRINT "Enter formulas, variable assignments, or commands."
370 GOSUB 3130
380 ANS$=NUL$
390 IF ME$<>NUL$ THEN PRINT ME$
400 ME$=NUL$:P$="OFF"
410 PRINT:PRINT "Enter: ";: ' prompt for input
420 GOSUB 440 ' get input
430 GOTO 820
440 ' input edit routine ' left and right arrows move cursor but don't erase
450 ' ^G deletes character ' ^V inserts space ' typing a character overprints
460 ' ^A brings back previous T$ for further editing  ' ^Z clears screen
470 ' statements 580-650 enable calculator keyboard
480 ' note: this routine also converts lower-case alphabetics into upper-case
490 C$=INPUT$(1)
500 IF ASC(C$)=1 THEN PRINT T$;STRING$(LEN(T$)-2,8);:P=3:I$=T$:GOTO 520
510 I$=NUL$:P=1:GOTO 540
520 C$=INPUT$(1)
530  IF ASC(C$)=1 THEN PRINT STRING$(P-1,8);:GOTO 500
540  IF ASC(C$)=26 AND P=1 THEN PRINT CLS$:GOTO 380
550  IF C$=E$ THEN PRINT CLS$:SYSTEM
560  IF C$=CR$ THEN PRINT:GOTO 800
570  IF KEY$="OFF" THEN GOTO 660
580  IF ASC(C$)=61 THEN C$="+"
590  IF ASC(C$)=95 THEN C$="-"
600  IF ASC(C$)=91 OR ASC(C$)=93 THEN C$="/"
610  IF ASC(C$)=11 THEN C$="*"
620  IF ASC(C$)=10 THEN C$="^"
630  IF ASC(C$)=92 OR ASC(C$)=124 THEN C$="("
640  IF ASC(C$)=34 OR ASC(C$)=39 THEN C$=")"
650  IF ASC(C$)=59 THEN C$="="
660  IF C$=BU$ THEN C$=BS$
670  IF C$=BS$ THEN IF P=1 THEN GOTO 520 ELSE GOTO 770
680  IF ASC(C$)=34 THEN GOTO 520
690  IF ASC(C$)=12 THEN IF P>LEN(I$) GOTO 520 ELSE GOTO 780
700  IF C$=BEL$ THEN I$=MID$(I$,1,P-1)+MID$(I$,P+1,LN-(P-1)):GOTO 790
710  IF ASC(C$)=22 THEN I$=MID$(I$,1,P-1)+BL$+MID$(I$,P,LN-P):GOTO 790
720  IF ASC(C$)<FC OR ASC(C$)>LC THEN 520
730  IF C$>="a" AND C$<="z" THEN C$=CHR$(ASC(C$) AND 95)
740  I$=MID$(I$,1,P-1)+C$+MID$(I$,P+1,LN-P)
750  IF P>LN THEN GOTO 520
760  PRINT C$;:P=P+1:GOTO 520
770  PRINT C$;:P=P-1:GOTO 520
780  PRINT MID$(I$,P,1);:P=P+1:GOTO 520
790  PRINT ERA$;MID$(I$,P,255);STRING$(LEN(I$)-(P-1),BS$);:GOTO 520
800  T$=I$
810 RETURN
820 ' parse infix expressions into tokens ' input: T$ ' output: I$(),I
830 ' note: variables are not evaluated on assignment
840 ' when called for, statement 1020 recycles until variables are evaluated
850 I$=T$:VARNAME$=I$:COMMA=INSTR(I$,","):IF COMMA>0 THEN VARNAME$=MID$(I$,1,COMMA-1)
860 IF I$=NUL$ THEN GOTO 390
870 VAR$="OFF":NOOSTR$="ON"
880 FOR C=1 TO I:I$(C)=NUL$:NEXT          ' clear old I$ entries
890 I=0
900 C=0
910 C=C+1:C$=MID$(I$,C,1)
920    IF C$=BL$ THEN GOTO 1100           ' strip blank characters
930    IF C$=":" OR C$="," THEN C$=NUL$   ' permit remarks and multiple commands
940    IF C$<>NUL$ THEN GOTO 970
950    ' see if first variable is a command name ' else process it
960    IF VAR$="ON" THEN IF I=1 THEN GOSUB 1150:GOTO 1040 ELSE GOTO 1040 ELSE GOTO 1810
970    GOSUB 2940 ' get character type (TP$)
980    IF TP$="Bad character" THEN ME$=TP$:GOTO 380
990    IF TP$="OPERATOR" THEN GOTO 1030
1000    IF TP$="NUMERIC" THEN IF NOOSTR$="ON" THEN GOTO 1080 ELSE IF NOOSTR$="NOTNUM" THEN GOTO 1100 ELSE GOTO 1070
1010    IF VAR$="OFF" AND NOOSTR$<>"ON" THEN GOTO 1060 ELSE VAR$="ON":IF NOOSTR$="ON" THEN I=I+1:GOTO 1070 ELSE GOTO 1070
1020     ' intercept assignment statements
1030    IF C$="=" THEN IF I=1 AND VAR$="ON" THEN ID$=I$(1):V$=RIGHT$(I$,LEN(I$)-C):GOSUB 1110:GOTO 380 ELSE GOTO 1060
1040    IF VAR$="ON" THEN ID$=I$(I):GOSUB 2540:IF ME$<>NUL$ THEN GOTO 380 ELSE I$="("+V$+")"+RIGHT$(I$,LEN(I$)-C+1):I$(I)=NUL$:I=I-1:NOOSTR$="ON":VAR$="OFF":GOTO 900
1050    I=I+1:I$(I)=C$:NOOSTR$="ON":VAR$="OFF":GOTO 1100
1060    ME$="Syntax error":GOTO 380
1070    I$(I)=I$(I)+C$:NOOSTR$="OFF":GOTO 1100
1080    I=I+1:G$=STR$(VAL(RIGHT$(I$,LEN(I$)-C+1)))
1090    I$(I)=RIGHT$(G$,LEN(G$)-1):C=C+(LEN(G$)-1)-1:NOOSTR$="NOTNUM"
1100 GOTO 910
1110 ' provide space in front of positive number assignment
1120 IF VAL(V$)>=0 THEN IF ASC(V$)<>45 THEN V$=BL$+V$
1130 GOSUB 2340
1140 RETURN
1150 ' commands
1160 IF I$(1)="HELP" THEN GOSUB 3000:GOTO 380      ' list commands
1170 IF LEFT$(I$(1),4)<>"LIST" THEN GOTO 1250      ' list variables
1180    ' list all variables
1190    IF I$(1)<>"LIST" THEN GOTO 1210
1200    GOSUB 2680:GOTO 380
1210    ' list only the named variable ' for editing
1220    ID$=RIGHT$(I$(1),LEN(I$(1))-4):Z=1:GOSUB 2540:IF ME$<>NUL$ THEN GOTO 380
1230    PRINT:PRINT "Enter: ";:IF VAL(V$)>=0 THEN V$=RIGHT$(V$,LEN(V$)-1)
1240    T$=ID$+"="+V$:C$=CHR$(1):GOSUB 500:GOTO 820
1250 IF LEFT$(I$(1),5)<>"STORE" THEN GOTO 1330     ' assign answer to variable
1260    IF ANS$=NUL$ THEN PRINT "No value to store":GOTO 380
1270    V$=ANS$:IF VAL(V$)>=0 THEN V$=BL$+V$ ELSE V$=V$
1280    COMMA=INSTR(6,I$,",")
1290    IF COMMA>0 THEN I$=MID$(I$,COMMA+1,255) ELSE I$=NUL$
1300    VARNAME$=I$:COMMA=INSTR(I$,","):IF COMMA>0 THEN VARNAME$=MID$(I$,1,COMMA-1)
1310    ID$=MID$(I$(1),6,255):GOSUB 2340:IF ME$=NUL$ THEN GOTO 860
1320    IF OU=PR AND P$="OFF" THEN LPRINT:LPRINT "Enter: "+T$:GOTO 390 ELSE GOTO 390
1330 IF I$(1)="PON" THEN OU=PR:GOTO 380            ' output to printer
1340 IF I$(1)="POFF" THEN OU=SC:GOTO 380           ' output to screen only
1350 IF I$(1)<>"KEYON" THEN GOTO 1420
1360 IF I$(1)="KEYON" THEN KEY$="ON"               ' BIZCALC keypad in effect
1370 PRINT CLS$:PRINT UY$+"BIZCALC Keypad Layout"+UN$:PRINT
1380 PRINT "4 right top row keys: "+UY$+"-"+UN$+" and "+UY$+"+"+UN$+" and "+UY$+"/"+UN$+" and "+UY$+"*"+UN$+"."
1390 PRINT "2 keys left of arrow keys in next row: "+UY$+"("+UN$+" and "+UY$+")"+UN$+"."
1400 PRINT "3 right keys next row are "+UY$+"="+UN$+" and "+UY$+"RETURN"+UN$+" and "+UY$+"^"+UN$+"."
1410 PRINT "Keys operate with and without shift except "+UY$+"="+UN$+" key.":PRINT "That key prints a colon when shifted.":GOTO 380
1420 IF I$(1)="KEYOFF" THEN KEY$="OFF":GOTO 380    ' normal keyboard in effect
1430 REM IF LEFT$(I$(1),4)="EXAM" THEN RESTORE:PRINT CLS$:FOR X=1 TO 15:READ X$:NEXT:PRINT UY$:READ X$:PRINT X$:PRINT UN$:FOR X=17 TO 35:READ X$:PRINT X$:NEXT:GOSUB 2790:GOTO 380
1440 IF LEFT$(I$(1),5)<>"CLEAR" THEN GOTO 1560     ' clear variables
1450    IF I$(1)="CLEARALL" THEN GOTO 1540
1460    IF I$(1)="CLEAR" THEN IF L3>1 THEN GOTO 1510 ELSE GOTO 1540
1470    ID$=RIGHT$(I$(1),LEN(I$(1))-5):GOSUB 2540:IF ME$<>NUL$ THEN GOTO 380
1480    N$(K)=NUL$:V$(K)=NUL$
1490    FOR J=K TO L3:SWAP N$(J),N$(J+1):SWAP V$(J),V$(J+1):NEXT
1500    L3=L3-1:GOTO 380
1510    PRINT CHR$(11);STRING$(12,12);"      ALL? (Y/N) ";
1520    J$=INPUT$(1):J=ASC(J$) AND 95
1530    IF J<>89 THEN PRINT "N":GOTO 380 ELSE PRINT "Y"
1540    FOR K=1 TO L3:N$(K)=NUL$:V$(K)=NUL$:NEXT:L3=0:GOTO 380
1550 ' save variables to, and get variables from, disk
1560 IF LEFT$(I$(1),4)<>"SAVE" AND LEFT$(I$(1),4)<>"LOAD" THEN GOTO 1600
1570    IF LEN(I$(1))>4 THEN FI$=RIGHT$(I$(1),LEN(I$(1))-4):GOTO 1590
1580    GOSUB 3260:FI$=I$:IF FI$=NUL$ THEN GOTO 380
1590    GOSUB 3300:IF LEFT$(I$(1),4)="LOAD" THEN GOTO 3410 ELSE GOTO 3530
1600 IF LEFT$(I$(1),3)<>"DIR" THEN GOTO 1660 ' directory function
1610    FI$=RIGHT$(I$(1),LEN(I$(1))-3):ON ERROR GOTO 3160
1620    IF FI$=NUL$ THEN FILES:PRINT:GOTO 380
1630    COL=INSTR(4,I$,":"):IF COL<>0 THEN FI$=MID$(I$,COL-1,255)
1640    IF LEN(FI$)=2 AND MID$(FI$,2,1)=":" THEN FI$=FI$+"*.*"
1650    FILES FI$:PRINT:GOTO 380
1660 IF I$(1)<>"TUTOR" THEN GOTO 1800
1670 PRINT CLS$:PRINT UY$+"Instructions"+UN$:PRINT
1680 PRINT "All alphabetic characters print uppercase only.":PRINT "Double quotes do not print."
1690 PRINT "Variable names must begin with a letter.":PRINT "They may contain numbers and the period."
1700 PRINT "Variable assignments follow an equal sign."
1710 PRINT "They may be in terms of other variables."
1720 PRINT "They may also contain remarks - after a colon."
1730 PRINT "+,-,*,/,exponentiation(^),and parentheses are OK."
1740 PRINT "Multiple entries may be made on one line."
1750 PRINT "Separate them with a comma.":PRINT
1760 PRINT UY$+"Editing Directions"+UN$:PRINT
1770 PRINT "Left/right arrows do not erase. Typing overprints."
1780 PRINT "^G deletes. ^V inserts space. ^Z clears screen."
1790 PRINT"^A recalls previous entry for editing.":GOTO 380
1800 RETURN
1810 ' convert infix expression to binary form : I$(),I into W$(),W
1820 IF I=0 THEN GOTO 380 ' reprompt if no entry
1830 W=0:NUM$="OFF":SIGN$="OFF":LP=0:RP=0
1840 FOR K=1 TO I
1850   W=W+1:W$=I$(K)
1860   IF W$=")" THEN RP=RP+1:IF RP>LP OR NUM$="OFF" THEN 2010 ELSE 1900
1870   IF W$="(" THEN LP=LP+1:IF NUM$="ON" THEN 2010 ELSE 1970
1880   C$=LEFT$(W$,1):GOSUB 2940:IF TP$<>"NUMERIC" THEN 1910
1890   IF SIGN$="ON" THEN SIGN$="OFF":NUM$="ON":GOTO 1980
1900   NUM$="ON":GOTO 1970
1910   IF W$="*" OR W$="/" OR W$="^" THEN IF NUM$="OFF" GOTO 2010 ELSE NUM$="OFF":GOTO 1970
1920   IF W$<>"+" AND W$<>"-" THEN 2010
1930   IF NUM$="ON" THEN NUM$="OFF":GOTO 1970
1940   IF SIGN$="OFF" THEN W$(W)="(":W=W+1:SIGN$="ON"
1950   IF W$="+" THEN W$(W)="1" ELSE W$(W)="-1"
1960   W=W+1:W$(W)="*":GOTO 1990
1970   W$(W)=W$:GOTO 1990
1980   W$(W)=W$:W=W+1:W$(W)=")"
1990 NEXT
2000 IF SIGN$="OFF" AND NUM$="ON" AND LP=RP THEN 2020
2010 ME$="Syntax error":GOTO 380
2020 ' perform operations in MBASIC precedence order
2030 ' parentheses first ' then (^) (*/) (+-) and left to right for = precedence
2040 S=1:T(1)=0  ' set stack number to 1, number of stack entries to zero
2050 FOR K=1 TO W
2060    J$=W$(K):J=ASC(J$)
2070    IF J$=")" THEN T=T(S):GOSUB 2310 ELSE GOTO 2090
2080    T(S)=0:S=S-1:T(S)=T(S)+1:NUM(S,T(S))=NUM(S+1,1):GOTO 2200
2090    IF J$="(" THEN S=S+1:GOTO 2200
2100    IF J$="^" THEN PREC=7:GOTO 2160
2110    IF J$="*" THEN PREC=5:GOTO 2160
2120    IF J$="/" THEN PREC=4:GOTO 2160
2130    IF J$="+" THEN PREC=2:GOTO 2160
2140    IF J$="-" THEN PREC=1:GOTO 2160
2150    T(S)=T(S)+1:NUM(S,T(S))=VAL(J$):GOTO 2200
2160    OPER(S,T(S))=PREC
2170    WHILE T(S)>1
2180        IF OPER(S,T(S))>OPER(S,T(S)-1)+1 THEN 2200 ELSE T=T(S):GOSUB 2790:T(S)=T
2190    WEND
2200 NEXT
2210 T=T(S):GOSUB 2310
2220 ANS$=STR$(NUM(1,1)):IF NUM(1,1)>=0 THEN ANS$=RIGHT$(ANS$,LEN(ANS$)-1)
2230 COMMA=INSTR(I$,","):IF COMMA=0 THEN I$=NUL$ ELSE I$=MID$(I$,COMMA+1,255)
2240 IF VARNAME$=T$ THEN VARNAME$=NUL$
2250 PRINT "Answer "+VARNAME$+"="+ANS$: ' display numeric answer
2260 IF OU=PR THEN IF P$="OFF" THEN P$="ON":GOTO 2270 ELSE GOTO 2280 ELSE GOTO 2290
2270 LPRINT:LPRINT "Enter: "+T$          ' print prompt line if appropriate
2280 LPRINT "Answer "+VARNAME$+"="+ANS$  ' print numeric answer
2290 VARNAME$=I$:COMMA=INSTR(I$,","):IF COMMA>0 THEN VARNAME$=MID$(I$,1,COMMA-1)
2300 GOTO 860: ' get new input
2310 ' finish calculations
2320 WHILE T>1:GOSUB 2790:WEND
2330 RETURN
2340 ' put variable into variable table ' input: ID$,V$ ' output: ME$
2350 IF ID$=NUL$ THEN ME$="No storage variable specified.":GOTO 2530
2360 K=0
2370 K=K+1: ' for each variable in the table already
2380    IF V$=NUL$ THEN ME$="No value to assign.":GOTO 2530
2390    COMMA=INSTR(V$,","):COLON=INSTR(V$,":")
2400    IF NOT COMMA<>0 AND (COLON=0 OR COMMA<COLON) THEN GOTO 2430
2410    G$=LEFT$(V$,COMMA-1):I$=RIGHT$(V$,LEN(V$)-COMMA):V$=G$:CO$="ON"
2420    VARNAME$=I$:COMMA=INSTR(I$,","):IF COMMA>0 THEN VARNAME$=MID$(I$,1,COMMA-1)
2430    IF N$(K)<>ID$ THEN GOTO 2480
2440    IF COLON<>0 THEN GOTO 2470
2450    COLON=INSTR(V$(K),":"):IF COLON=0 THEN GOTO 2470
2460    IF COLON>LEN(V$) THEN V$=V$+STRING$(COLON-LEN(V$)-1,32)+MID$(V$(K),COLON,255) ELSE V$=V$+MID$(V$(K),COLON,255)
2470    V$(K)=V$:GOTO 2510
2480    IF K<L3 THEN GOTO 2370
2490    IF L3=MV THEN ME$="No more variables allowed. ":GOTO 2530
2500    L3=L3+1:N$(L3)=ID$:V$(L3)=V$: ' add value to variable table
2510    IF OU=PR AND P$="OFF" THEN P$="ON":LPRINT:LPRINT "Enter: "+T$
2520    IF CO$<>NUL$ THEN CO$=NUL$:GOTO 870
2530 RETURN
2540 ' get variable from variable table ' input: ID$ ' output: V$,ME$
2550 K=0
2560 K=K+1
2570    IF K>L3 THEN ME$=ID$+" is undefined":GOTO 2670
2580    IF N$(K)=ID$ THEN V$=V$(K):J$=NUL$ ELSE GOTO 2660
2590    IF Z=1 THEN Z=0:GOTO 2670          ' leave comments for LIST
2600    FOR J=1 TO LEN(V$)                 ' strip comments for evaluation
2610      K$=MID$(V$,J,1)
2620      IF K$=":" THEN GOTO 2650
2630      J$=J$+K$
2640    NEXT
2650    V$=J$:GOTO 2670
2660 GOTO 2560
2670 RETURN
2680 ' display variables
2690 IF L3<1 THEN ME$="No variables set":GOTO 2780
2700 IF OU=PR AND P$="OFF" THEN LPRINT:LPRINT "Enter: "+T$
2710 PRINT CLS$;SPC(18);"Set Variables"
2720 PRINT UY$;"                                                    ";UN$:PRINT
2730 IF OU=PR THEN LPRINT "_______________ SET VARIABLES ______________":LPRINT
2740 FOR K=1 TO L3
2750    PRINT N$(K);" = ";V$(K)
2760    IF OU=PR THEN LPRINT N$(K);" = ";V$(K) 
2770 NEXT
2780 RETURN
2790 ' perform actual calculations using MBASIC routines
2800 IF OPER(S,T-1)=7 THEN NUM(S,T-1)=NUM(S,T-1)^NUM(S,T):GOTO 2870
2810 IF OPER(S,T-1)=5 THEN NUM(S,T-1)=NUM(S,T-1)*NUM(S,T):GOTO 2870
2820 IF OPER(S,T-1)=4 THEN IF NUM(S,T)=0 GOTO 2850 ELSE GOTO 2860
2830 IF OPER(S,T-1)=2 THEN NUM(S,T-1)=NUM(S,T-1)+NUM(S,T):GOTO 2870
2840 IF OPER(S,T-1)=1 THEN NUM(S,T-1)=NUM(S,T-1)-NUM(S,T):GOTO 2870
2850 ME$="Division by zero is not allowed":GOTO 380
2860 NUM(S,T-1)=NUM(S,T-1)/NUM(S,T)
2870 T=T-1:OPER(S,T)=OPER(S,T+1)
2880 RETURN
2890 ' wait for response
2900 PRINT:PRINT SPC(13);"Press any key to continue...";CO$
2910 K$=INKEY$:IF K$=NUL$ THEN GOTO 2910
2920 PRINT CLS$:GOSUB 3130
2930 RETURN
2940 ' determine character type ' input: C$ ' output: TP$
2950 TP$="Bad character"
2960 IF (C$>="0" AND C$<="9") OR C$="." THEN TP$="NUMERIC":GOTO 2990
2970 IF C$=")" OR C$="(" OR C$="+" OR C$="-" OR C$="*"OR C$="/" OR C$="^" OR C$="=" THEN TP$="OPERATOR":GOTO 2990
2980 IF C$>="A" AND C$<="Z" THEN TP$="ALPHA"
2990 RETURN
3000 ' list commands
3010 PRINT CLS$:RESTORE
3020 PRINT SPC(6) "            List of Commands":PRINT
3030 PRINT SPC(6) "PON"+DY$+"/"+UY$+"POFF"+DN$+UN$;:GOTO 3050
3040 PRINT SPC(6) DY$+UY$+"PON"+UN$+"/"+DN$+"POFF";
3050 PRINT "............Turn Printer ON/OFF":PRINT
3060 IF KEY$="ON" THEN GOTO 3080
3070 PRINT SPC(6) "KEYON"+DY$+"/"+UY$+"KEYOFF"+DN$+UN$;:GOTO 3090
3080 PRINT SPC(6) DY$+UY$+"KEYON"+UN$+"/"+DN$+"KEYOFF";
3090 PRINT "........Turn BIZCALC Keypad ON/OFF":PRINT
3100 FOR X=1 TO 13:READ X$:PRINT SPC(6) X$:NEXT
3110 GOSUB 2890
3120 RETURN
3130 ' prints help message
3140 PRINT: PRINT "Need help? Type ";UY$;"HELP";UN$;" after colon."
3150 RETURN
3160 ' error processing
3170 IF ERR=64 THEN PRINT FI$+" is a bad file name":RESUME 3250
3180 IF ERR<>53 THEN GOTO 3220
3190 IF ERL=3430 THEN PRINT "Can't find "+FI$:RESUME 3250
3200 IF ERL=3560 THEN RESUME 3590
3210 IF ERL=1620 OR ERL=1650 THEN PRINT "File not found": RESUME 3250
3220 IF ERR=61 THEN PRINT "No disk space":RESUME 3250
3230 IF ERR=67 THEN PRINT "No directory space":RESUME 3250
3240 PRINT "Unprintable error":RESUME 3250
3250 CLOSE #1:ON ERROR GOTO 0:GOTO 380
3260 ' prompt for file name
3270 PRINT "File name ? ";
3280 HOLDER$=KEY$:KEY$="OFF":GOSUB 440:KEY$=HOLDER$
3290 RETURN
3300 ' process file name
3310 J$=NUL$:SW=1
3320 FOR J=1 TO LEN(FI$)
3330   C$=MID$(FI$,J,1)
3340   IF C$=BL$ THEN 3370                           ' delete any blanks
3350   IF C$="." THEN SW=0                           ' test for file extension
3360   J$=J$+C$
3370 NEXT
3380 IF J$<>NUL$ THEN IF SW=1 THEN J$=J$+".BIC"      ' default extension is BIC
3390 FI$=J$
3400 RETURN
3410 ' load variables from disk file
3420 ON ERROR GOTO 3160
3430 OPEN "I",#1,FI$
3440 FOR J=1 TO MV
3450   IF EOF(1) THEN GOTO 3480
3460   INPUT #1,N$(J),V$(J)
3470 NEXT
3480 CLOSE #1
3490 ON ERROR GOTO 0
3500 IF J=1 THEN PRINT "No variables in file.":GOTO 3520
3510 PRINT "Variables loaded."
3520 GOTO 380
3530 ' save variables to disk file
3540 IF L3=0 THEN PRINT "No variables to save.":GOTO 3640
3550 ON ERROR GOTO 3160
3560 OPEN "I",#1,FI$
3570 CLOSE #1:PRINT FI$+" exists. Overwrite ? (Y/N)";
3580 C$=INPUT$(1):IF C$<>"Y" THEN ON ERROR GOTO 0:GOTO 380
3590 OPEN "O",#1,FI$
3600 FOR J=1 TO L3:PRINT #1,N$(J);",";V$(J);:NEXT
3610 CLOSE #1
3620 ON ERROR GOTO 0
3630 PRINT "Variables saved."
3640 GOTO 380
3650 DATA "STORE <Variable>....Store calculated value"
3660 DATA " "
3670 DATA "LIST <Variable>.....List variable for editing"
3680 DATA " "
3690 DATA "LIST................List all variables"
3700 DATA " "
3710 DATA "CLEAR [<Variable>]..Clear variable(s)"
3720 DATA " "
3730 DATA "SAVE/LOAD...........Variables to/from disk"
3740 DATA " "
3750 DATA "DIR [<Disk:/File>]..Directory function"
3760 DATA " "
3770 DATA "TUTOR...............How to use BIZCALC"
3780 DATA Examples
3790 DATA "Enter: 4+6-5*5+3^2","Answer =-6"," ","Enter: A=4+(6-5)*5+3^2"," "
3800 DATA "Enter: A","Answer =18"," "
3810 DATA "Enter: B=C*A          :Comment after colon OK"," "
3820 DATA "Enter: C=2            :Comment?"," "
3830 DATA "Enter: B","Answer =36"," ","Enter: C=3"," "
3840 DATA "Enter: B","Answer =54"
3850 END
          :Comment?"," "
3830 DATA "Enter: B","Answer =36"," ","Enter: C=3"," "
3840 DATA "En